#ifndef PolyMapH
#define PolyMapH
//---------------------------------------------------------------------------
#include "myPolyBool.h"
#include <dstring.h>
#include <StdCtrls.hpp>

struct pmPoint{
  int x,y;
  pmPoint* next;
};

class pmMap{
public:
  // 
  PAREA* revealed;
  PAREA* obstacles;

  //     
  PAREA* restricted;
  PAREA* safe_distanced;

  TMemo* tm;

  //    
  double vert_x[1000];
  double vert_y[1000];
  int vert_qty;
  int graph_ready;
  double graph[1000][1000];

  //   
  int vert_queue[1000];
  int vert_from[1000];
  int vert_flag[1000];
  double vert_dist[1000];

  PLINE2* getAroundLine(int x1, int y1, int x2, int y2, int safe_distance, int rounding_size);
  int intersectLine2Lines(int x1, int y1, int x2, int y2, int xp, int yp, int xc, int yc, int xn, int yn);
  int intersectLinePAREA(int x1, int y1, int x2, int y2, PAREA* p);
  void stepBackSafeDistance(int safe_distance, int rounding_size);
  void getRestricted(int only_revealed);
  void generateVertexList();
  void generateGraph();

public:
  pmMap();
  ~pmMap();
  void saveToFile(const char* filename);
  void loadFromFile(const char* filename);
  void addObstacle(pmPoint* poly);
  void addFreeSpace(pmPoint* poly);
  void prepareWayFindingMap(int safe_distance, int rounding_size, int only_revealed);
  pmPoint* findShortestWay(pmPoint* start, pmPoint* finish);
};

//---------------------------------------------------------------------------
#endif
