//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "myPolyBool.h"
#include "PolyMap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

using namespace POLYBOOLEAN;

TForm1 *Form1;

pmMap* p;

int scale=2;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

};

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
        pmPoint* pp=new pmPoint();
        pmPoint* qq=new pmPoint();
        pp->x=TrackBar1->Position;
        pp->y=TrackBar2->Position;
        qq->x=TrackBar3->Position;
        qq->y=TrackBar4->Position;

        TRect r;
        r.left=0;
        r.top=0;
        r.right=400;
        r.Bottom=400;
        Image2->Canvas->Brush->Color=clWhite;
        Image2->Canvas->FillRect(r);

        mybpDrawPAREA(Image2,p->safe_distanced,clRed,clYellow,200,200,scale);

        for(int i=0; i<p->vert_qty; i++){
          int x=200+scale*p->vert_x[i];
          int y=200+scale*p->vert_y[i];
          Image2->Canvas->Pen->Color=clBlack;
          Image2->Canvas->Ellipse(x-2,y-2,x+2,y+2);
          for(int j=i+1; j<p->vert_qty; j++){
            if(p->graph[i][j]>=0){
              Image2->Canvas->Pen->Color=clGray;
              Image2->Canvas->MoveTo(scale*p->vert_x[i]+200,scale*p->vert_y[i]+200);
              Image2->Canvas->LineTo(scale*p->vert_x[j]+200,scale*p->vert_y[j]+200);
            };
          };
        };

        pmPoint* m=p->findShortestWay(pp,qq);

        pmPoint* n=m;
        if(n!=NULL){
          Image2->Canvas->Pen->Color=clBlack;
          Image2->Canvas->Pen->Width=3;
          Image2->Canvas->MoveTo(scale*n->x+200,scale*n->y+200);
          n=n->next;
        };
        while( n!=NULL ){
          Image2->Canvas->LineTo(scale*n->x+200,scale*n->y+200);
          n=n->next;
        };
        Image2->Canvas->Pen->Width=1;

}

//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{

        p=new pmMap();

	GRID2 b[11] =
	{ {-50, -60}, {70,-60}, {70, 40}, {-50, 40}, {0, 0}, {0, 20},
	{50, 20}, {50, -40}, {0, -40}, {0, 0}, {-50, 0} };

        GRID2 c[4] =
	{ {-85, -5}, {-85,5}, {-75, 5}, {-75, -5} };

        GRID2 d[4] =
	{ {25, -5}, {25,5}, {35, 5}, {35, -5} };

	PAREA * B = NULL;
	int     i;
	PLINE2 * pline = NULL;

	// construct B polygon
	pline = NULL;
	for (i = 0; i < 11; i++) PLINE2::Incl(&pline, b[i]);
	pline->Prepare();
	if (not pline->IsOuter()) // make sure the contour is outer
	pline->Invert();
	PAREA::InclPline(&B, pline);

        // construct C polygon
	pline = NULL;
	for (i = 0; i < 4; i++) PLINE2::Incl(&pline, c[i]);
	pline->Prepare();
	if (not pline->IsOuter()) // make sure the contour is outer
	pline->Invert();
	PAREA::InclPline(&B, pline);

        // construct D polygon
	pline = NULL;
	for (i = 0; i < 4; i++) PLINE2::Incl(&pline, d[i]);
	pline->Prepare();
	if (not pline->IsOuter()) // make sure the contour is outer
	pline->Invert();
	PAREA::InclPline(&B, pline);

        mybpDrawPAREA(Image1,B,clBlack,clBlue,200,200,scale);

        p->obstacles=B->Copy();

        p->prepareWayFindingMap(6, 2, 0);

        mybpDrawPAREA(Image2,p->safe_distanced,clRed,clYellow,200,200,scale);

        for(int i=0; i<p->vert_qty; i++){
          int x=200+scale*p->vert_x[i];
          int y=200+scale*p->vert_y[i];
          Image2->Canvas->Pen->Color=clBlack;
          Image2->Canvas->Ellipse(x-2,y-2,x+2,y+2);
          for(int j=i+1; j<p->vert_qty; j++){
            if(p->graph[i][j]>=0){
              Image2->Canvas->Pen->Color=clGray;
              Image2->Canvas->MoveTo(scale*p->vert_x[i]+200,scale*p->vert_y[i]+200);
              Image2->Canvas->LineTo(scale*p->vert_x[j]+200,scale*p->vert_y[j]+200);
            };
          };
        };

	PAREA::Del(&B);

        TrackBar1Change(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
  Shape1->Left=Image2->Left+200+scale*TrackBar1->Position-2;
  Shape1->Top=Image2->Top+200+scale*TrackBar2->Position-2;
  Shape2->Left=Image2->Left+200+scale*TrackBar3->Position-2;
  Shape2->Top=Image2->Top+200+scale*TrackBar4->Position-2;
  Label1->Caption="Start X="+IntToStr(TrackBar1->Position);
  Label2->Caption="Start Y="+IntToStr(TrackBar2->Position);
  Label3->Caption="Finish X="+IntToStr(TrackBar3->Position);
  Label4->Caption="Finish Y="+IntToStr(TrackBar4->Position);
}
//---------------------------------------------------------------------------

